<app-loading *ngIf='isLoading'></app-loading>
<div class="form-setup-header">
  <form [formGroup]="formControl">
  <div nz-row [nzGutter]="[30, 10]">
    <div nz-col nzSm="24" nzXs="24" nzLg="6">
      <mb-select [mbDataSelects]="listDataSyntheticOrgLine$?.data" [mbShowSearch]="true"
                 mbLabelText="{{'goaManagement.handleClassification.label.orgName' | translate}}"
                 mbKeyLabel="name"
                 mbKeyValue="dataId"
                 formControlName="dataId"
      >
      </mb-select>
    </div>

    <div nz-col nzSm="24" nzXs="24" nzLg="6">
      <mb-select [mbDataSelects]="dataAssessmentPeriod$?.data" [mbShowSearch]="true"
                 mbLabelText="{{'goaManagement.system-allocation.label.attribute.CodeAllocation' | translate}}"
                 mbKeyLabel="periodName"
                 mbKeyValue="periodId"
                 formControlName="periodId"
      >
      </mb-select>
    </div>

    <div nz-col nzSm="24" nzXs="24" nzLg="6" *ngIf="listApportioned$ | async as listApportioned;">
      <mb-select [mbDataSelects]="listApportioned" [mbShowSearch]="false"
                 mbLabelText="{{'goaManagement.handleClassification.label.classificationInOrOut' | translate}}"
                 mbKeyLabel="label"
                 mbKeyValue="value"
                 formControlName="apportion"
      >
      </mb-select>
    </div>

    <div nz-col nzSm="24" nzXs="24" nzLg="6" *ngIf="listFlagStatus$ | async as listFlagStatus;">
      <mb-select [mbDataSelects]="listFlagStatus" [mbShowSearch]="false"
                 mbLabelText="{{'goaManagement.common.flagStatus' | translate}}"
                 mbKeyLabel="label"
                 mbKeyValue="value"
                 formControlName="flagStatus"
      >
      </mb-select>
    </div>
  </div>
  </form>
  <div class="search_handleClassification">
    <mb-button mbButtonAvailableStyle="CUSTOM" (click)="search()"
               mbButtonText="{{'common.label.search' | translate}}"></mb-button>
  </div>
</div>

<!--table child-->
<section class="table-header">
  <article class="table-current_info">
    <div nz-row [nzGutter]="16">
      <div nz-col class="gutter-row" [nzSpan]="6">
        <div class="inner-box">
        {{'goaManagement.handleClassification.label.totalEmployee' | translate}}: {{dataTable?.data?.totalEmp}}
        </div>
      </div>
      <div nz-col class="gutter-row" [nzSpan]="6">
        <div class="inner-box">
          {{'goaManagement.handleClassification.label.classificationIn' | translate}}: {{dataTable?.data?.inApportion}}
        </div>
      </div>
      <div nz-col class="gutter-row" [nzSpan]="6">
        <div class="inner-box">
          {{'goaManagement.handleClassification.label.classificationLineOrGoup' | translate}}: {{dataTable?.data?.rating}}
        </div>
      </div>
    </div>
    <h4>{{'goaManagement.handleClassification.label.currentRatingDTOS' | translate}}</h4>
    <nz-table
      *ngIf="dataTable?.data?.currentRatingDTOS.length > 0"
      [nzData]="dataTable?.data?.currentRatingDTOS"
      #rowSelectionTableCurrent
      [nzShowPagination]="false"
      nzTableLayout="fixed"
      nzSize="small"
    >
      <thead>
      <tr>
        <th scope="col">&nbsp;</th>
        <th scope="col" *ngFor="let elHeader of dataTable?.data?.classificationList">{{elHeader.cldName}}</th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let itemCurrRating of rowSelectionTableCurrent.data">
        <td>
          <container-element [ngSwitch]="itemCurrRating?.apportion">
            <p *ngSwitchCase="1">{{'goaManagement.handleClassification.label.classificationIn' | translate}}</p>
            <p *ngSwitchCase="0">{{'goaManagement.handleClassification.label.classificationOut' | translate}}</p>
          </container-element>
        </td>
        <ng-container *ngFor="let itemSefl of itemCurrRating?.currentRatingDetailDTOS" >
          <td>
            <article *ngFor="let elHeader of dataTable?.data?.classificationList; index as isIndex; count as isCount ">
              <div *ngIf="elHeader?.claCode === itemSefl?.claCode" [ngStyle]="{'color': itemSefl.isRed && ( isCount - 3) > isIndex ? 'red': null }">
                <p>
                  {{ itemSefl?.numberEmpReal | transformFormatPercent: 'prev' : 'notPercent'}}
                  {{ itemSefl?.numberEmpRealApportion | transformFormatPercent: 'curr' : 'notPercent'}}
                </p>
                <p>
                  ({{ itemSefl?.perNumberEmpReal | transformFormatPercent: 'prev' : 'percent'}}
                  {{ itemSefl?.perNumberEmpApportion | transformFormatPercent: 'curr' : 'percent'}})
                </p>
              </div>
            </article>
          </td>
        </ng-container>
      </tr>
      </tbody>
    </nz-table>
  </article>

<!--  list suggestion-->
  <article class="table-info_main">
    <div nz-row [nzGutter]="16">
      <div nz-col class="gutter-row" [nzSpan]="12">
        <div class="inner-box_left">{{'goaManagement.handleClassification.label.listSuggest' | translate}}</div>
      </div>
      <div nz-col class="gutter-row" [nzSpan]="12">
        <div class="inner-box_right">
          <mb-button mbButtonType='BORDER'
                     *ngIf='objFunction?.approve'
                     mbButtonSize='SMALL'
                     mbButtonAvailableStyle='PRIMARY'
                     mbButtonText="{{'goaManagement.common.approval' | translate}}"
                     (click)="approvalSelect()"
          >
          </mb-button>
          <mb-button mbButtonType='BORDER'
                     *ngIf='objFunction?.approve'
                     mbButtonSize='SMALL'
                     mbButtonAvailableStyle='PRIMARY'
                     mbButtonText="{{'goaManagement.common.rejectApproval' | translate}}"
                     (click)='onDisplayModalRejectDataSelected()'
          >
          </mb-button>
          <mb-button *ngIf="objFunction?.edit" mbButtonType="BORDER" mbButtonSize="VERY_LARGE" (click)="exportExelTable()">
            <img src="../../../../../assets/images/icon/excel.svg" alt="exportexel" />
          </mb-button>
        </div>
      </div>
    </div>

<!--    table-->
    <nz-table
      #rowSelectionTableInfo
      nzShowSizeChanger
      [nzData]="dataTable?.data?.changeRatingDTOS.content"
      (nzCurrentPageDataChange)="onCurrentPageDataChange($event)"
      [nzShowPagination]="false"
      nzTableLayout="fixed"
      nzSize="small"
    >
      <thead>
      <tr>
        <th
          [nzSelections]="listOfSelection"
          [nzChecked]="checked"
          [nzIndeterminate]="indeterminate"
          (nzCheckedChange)="onAllChecked($event)"
          nzWidth="50px"
          scope="col"
        ></th>
        <th scope="col">{{'goaManagement.handleClassification.table.orgName' | translate}}</th>
        <th scope="col">{{'goaManagement.handleClassification.table.caculatorOrg' | translate}}</th>
        <th scope="col">{{'goaManagement.handleClassification.table.caculatorLine' | translate}}</th>
        <th scope="col">{{'goaManagement.handleClassification.table.area' | translate}}</th>
        <th scope="col">{{'goaManagement.handleClassification.label.classificationInOrOut' | translate}}</th>
        <th scope="col" *ngFor="let elHeader of dataTable?.data?.classificationList">{{elHeader.cldName}}</th>
        <th scope="col">{{'goaManagement.common.flagStatus' | translate}}</th>
        <th scope="col"></th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let itemSuggestRating of rowSelectionTableInfo.data">
        <td
          [nzChecked]="setOfCheckedId.has(itemSuggestRating.id)"
          (nzCheckedChange)="onItemChecked(itemSuggestRating.id, $event)"
          [nzDisabled]="itemSuggestRating?.disabled"
          nzWidth="50px"
        ></td>
        <td>{{ itemSuggestRating?.orgName }}</td>
        <td>{{ itemSuggestRating?.ratingOrg }}</td>
        <td>{{ itemSuggestRating?.ratingLineCn }}</td>
        <td>{{ itemSuggestRating?.district }}</td>
        <td>
          <container-element [ngSwitch]="itemSuggestRating?.apportion">
            <p *ngSwitchCase="1">{{'goaManagement.handleClassification.label.classificationIn' | translate}}</p>
            <p *ngSwitchCase="0">{{'goaManagement.handleClassification.label.classificationOut' | translate}}</p>
          </container-element>
          </td>
        <ng-container *ngFor="let itemSefl of itemSuggestRating?.currentRatingDetailDTOS" >
          <td>
            <article *ngFor="let elHeader of dataTable?.data?.classificationList; index as isIndex; count as isCount ">
              <div *ngIf="elHeader?.claCode === itemSefl?.claCode" [ngStyle]="{'color': itemSefl.isRed && ( isCount - 3) > isIndex  ? 'red': null }">
                <p>
                  {{ itemSefl?.numberEmpReal | transformFormatPercent: 'prev' : 'notPercent'}}
                  {{ itemSefl?.numberEmpRealApportion | transformFormatPercent: 'curr' : 'notPercent'}}
                </p>
                <p>
                  ({{ itemSefl?.perNumberEmpReal | transformFormatPercent: 'prev' : 'percent'}}
                  {{ itemSefl?.perNumberEmpApportion | transformFormatPercent: 'curr' : 'percent'}})
                </p>
              </div>
            </article>
          </td>
        </ng-container>
        <td>
          <nz-tag
            [class]="(itemSuggestRating?.flagStatus | statusHandleClassification).class"
          >
            {{(itemSuggestRating?.flagStatus | statusHandleClassification).text}}
          </nz-tag>
        </td>
        <td nzRight>
          <div class="main-model-organization__tooltip">
            <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Example icon-button with a menu" class="main-model-organization__tooltip__button">
              <mat-icon class="main-model-organization___tooltip__icon">more_vert</mat-icon>
            </button>
            <mat-menu #menu="matMenu" class="main-model-organization__tooltip__menu">
              <div *ngIf="objFunction?.edit && (itemSuggestRating?.flagStatus === 1 || itemSuggestRating?.flagStatus === 2 || itemSuggestRating?.flagStatus === 0)"
                   class="main-model-organization__tooltip__menu--item"
                   mat-menu-item
                   (click)="onCorrectionItem(
                     itemSuggestRating,
                     itemSuggestRating?.currentRatingDetailDTOS,
                     dataTable?.data?.classificationList,
                     footerTmplTable
                   )"
              >
                {{'goaManagement.common.correction' | translate}}
              </div>
              <div *ngIf="objFunction?.approve && itemSuggestRating?.flagStatus === 0"
                   class="main-model-organization__tooltip__menu--item"
                   mat-menu-item
                   (click)="onApprovalItem(itemSuggestRating?.currentRatingDetailDTOS,undefined)"
              >
                {{'goaManagement.common.approval' | translate}}
              </div>
              <div *ngIf="objFunction?.approve && itemSuggestRating?.flagStatus === 0"
                   class="main-model-organization__tooltip__menu--item"
                   mat-menu-item
                   (click)='onDisplayModalReject(2, itemSuggestRating?.currentRatingDetailDTOS)'
              >
                {{'goaManagement.common.Reject' | translate}}
              </div>
              <div *ngIf="objFunction?.export"
                   class="main-model-organization__tooltip__menu--item"
                   mat-menu-item
                   (click)='onExportItem(itemSuggestRating)'
              >
                {{'goaManagement.common.exportExel' | translate}}
              </div>
            </mat-menu>
          </div>
        </td>
      </tr>
      </tbody>
    </nz-table>
    <!--    pagination-->
    <div class="pagination" *ngIf="dataTable?.data?.changeRatingDTOS?.content?.length">
      <div class="pagination__table-info">
        <img class="pagination__table-info--icon" src="assets/images/icon/idea.svg" alt="">
        <span class="pagination__table-info--text"> {{'common.paging.rangePage' |
          translate:{result:pagination.totalElements} }}
          {{ pagination?.size * (pagination?.currentPage - 1) + 1 }} {{'common.paging.to' | translate}}
          {{ pagination?.size * (pagination?.currentPage - 1) + pagination?.numberOfElements }}
      </span>
      </div>
      <nz-pagination [nzPageIndex]="pagination.currentPage" [nzTotal]="pagination.totalElements"
                     [nzPageSize]="pagination.size" (nzPageIndexChange)="changePage($event)" class="pagination__icon">
      </nz-pagination>
    </div>
    <!--    end pagination-->
  </article>
</section>

<ng-template #footerTmplTable>
  <mb-button mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.saveS' | translate}}"
             (click)="modalRef.getContentComponent().save()">
  </mb-button>
  <mb-button mbButtonAvailableStyle="BtnCancelHasBorder" mbButtonText="{{'common.button.cancel' | translate}}" (click)="modalRef.destroy()">
  </mb-button>
</ng-template>

<mb-modal-confirm #modalCompReject
                  [modalHeader]="'Từ chối đề xuất phân bổ xếp loại'"
                  [isVisibleCorrectionDialog]='false'
                  (sendApprovedValid)='rejectListSuggest($event)'
                  titleInputText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                  mbPlaceholderText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                  [mbErrorDefs]="[
                            { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
                            { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate:
                            {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
                            { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate:
                            {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }}]"
>
</mb-modal-confirm>





